
quicksort([], []).
quicksort([Prim | Rest], LOrd) :- 
    partition(Prim, Rest, Esq, Dre),
    quicksort(Esq, LOrdE),
    quicksort(Dre, LOrdD),
    append(LOrdE, [Prim | LOrdD], LOrd).


partition(P, [], [], []).
partition(P, [X | R], [X | Esq], Dre) :- 
    X =< P,
    partition(P, R, Esq, Dre).
partition(P, [X | R], Esq, [X | Dre]) :- 
    X > P,
    partition(P, R, Esq, Dre).

%quicksort([8, 10, 2, 6, 17, 13, 1, 4, 8, 16, 7],Ord).
